<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method='html' version='1.0' encoding='UTF-8' indent='no'/>

<xsl:template match="/">
<html>
<head>
	<title><xsl:value-of select="semanticpage/title"/></title>
	<meta http-equiv='content-type' content='text/html; charset=UTF-8' />
<style>
body
{
	background-repeat: no-repeat;
	background-position: top left;
	background-attachment: fixed;
	background-image: url('<xsl:value-of select="semanticpage/server"/>bin/SemanticOutputHandler/bg.png');
}
.Sitemap
{
	margin-top: 150px;
	width: 20%;
}
.Stop, .Smidt, .Sbund
{
	width: 270px;
}

.Stop, .Sbund
{
	background-repeat: no-repeat;
	height: 38px;
}

.Stop
{
	background-image: url('<xsl:value-of select="semanticpage/server"/>bin/SemanticOutputHandler/top.png');
}
.Smidt
{
	background-repeat: repeat-y;
	background-image: url('<xsl:value-of select="semanticpage/server"/>bin/SemanticOutputHandler/midt.png');
	padding-left: 25px;
	padding-right: 25px;
	width: 220px;
}
.Sbund
{
	background-image: url('<xsl:value-of select="semanticpage/server"/>bin/SemanticOutputHandler/bund.png');
}
.Smidt blockquote
{
	margin-top: 0px;
	margin-bottom: 0px;
	margin-left: 25px;
}
</style>
<!--A small firefox hack, there's probably some good reason they don't implement disable-output-escaping support -->
<script type="text/javascript">
<![CDATA[
// A workaround for XSL-to-XHTML systems that don't
//  implement XSL 'disable-output-escaping="yes"'.
//
// sburke@cpan.org, Sean M. Burke.
//  - I hereby release this JavaScript code into the public domain.

var is_decoding;
var DEBUG = 0;

function complaining (s) { alert(s);  return s; }

if(!(   document.getElementById && document.getElementsByName))
 throw complaining("Your browser is too old to render this page properly."
  + "  Consider going to getfirefox.com to upgrade.");

function check_decoding () {
  var d = document.getElementById('cometestme');
  if(!d) {
    throw complaining("Can't find an id='cometestme' element?");
  } else if(!('textContent' in d)) {
    // It's a browser with a halfassed DOM implementation (like IE6)
    // that doesn't implement textContent!  Assume that if it's that
    // dumb, it probably doesn't implement disable-content-encoding.

  } else {
    ampy = d.textContent;
    if(DEBUG > 1) { alert("Got " + ampy); }

    if(ampy == undefined) throw complaining("'cometestme' element has undefined text content?!");
    if(ampy == ''       ) throw complaining("'cometestme' element has empty text content?!"    );

    if      (ampy == "\x26"	) { is_decoding =  true; }
    else if (ampy == "\x26amp;" ) { is_decoding = false; }
    else		     { throw complaining('Insane value: "' + ampy + '"!'); }
  }

  var msg =
   (is_decoding == undefined) ? "I can't tell whether the XSL processor supports disable-content-encoding!D"
   : is_decoding ? "The XSL processor DOES support disable-content-encoding"
   : "The XSL processor does NOT support disable-content-encoding"
  ;
  if(DEBUG) alert(msg);
  return msg;
}


function go_decoding () {
  check_decoding();

  if(is_decoding) {
    DEBUG && alert("No work needs doing -- already decoded!");
    return;
  }

  var to_decode = document.getElementsByName('decodeable');
  if(!( to_decode && to_decode.length )) {
    DEBUG && alert("No work needs doing -- no elements to decode!");
    return;
  }


  var s;
  for(var i = to_decode.length - 1; i >= 0; i--) { 
    s = to_decode[i].textContent;

    if(
      s == undefined ||
      (s.indexOf('&') == -1 && s.indexOf('<') == -1)
    ) {
      // the null or markupless element needs no reworking
    } else {
      to_decode[i].innerHTML = s;  // that's the magic
    }
  }

  return;
}


//End


//utility function for appending USM param on existing URL, parameterized or otherwise

function encodeUSMParam(theURL) {

	var rslt = "XXX";

	if (theURL.indexOf('?') > 0) {
		rslt = encodeURI(theURL + "&format=usm");
	} else {
		rslt = theURL + "?format=usm";
	}

	return rslt;

}]]>
</script>
</head>
<body onload="go_decoding();">
<div id="cometestme" style="display:none;">
          <xsl:text disable-output-escaping="yes">&amp;amp;</xsl:text>
        </div>
<table>
<tr><td valign="top">
<div class="Sitemap">
	<div class="Stop"></div>
	<div class="Smidt"><b>Did you know?</b><br />That this page is an xml page transformed with xsl, try to right click and choose show source. You may use this xml schema to make your web services interact with my website.</div>
	<div class="Sbund"></div>
</div>
</td><td valign="top">
<div class="Content"  name="decodeable">
<xsl:value-of disable-output-escaping="yes" select="semanticpage/content/para"/>
<xsl:for-each select="semanticpage/content/subpara">
<xsl:if test="@headline != ''">
&lt;h2&gt;<xsl:value-of select="@headline"/>&lt;/h2&gt;
</xsl:if>
&lt;p&gt;<xsl:value-of disable-output-escaping="yes" select="."/>&lt;/p&gt;
</xsl:for-each>
</div>
</td></tr>
</table>
</body>
</html>
</xsl:template>

</xsl:stylesheet>
