<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines CMS3_LogViewer
*
* @package	LogViewer
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/*
*LogViewer provides a frontend for viewing logfiles.
*/
class CMS3_LogViewer extends CMS3_System_Plugin implements IConfigure //TODO: Perhaps implement IProvidesHelp
{

	//IConfigure implementation

	/**
	* Gets an absolute address of an icon for this plugin
	*/
	public function GetControlCenterIcon(){
		return $this->Owner->GetCMS3URL() . "bin/" . $this->GetPluginID() . "/LogICO.png";
	}

	/**
	* Gets menu entry string
	*/
	public function GetControlCenterMenuEntry(){
		//TODO: i18n
		return "View system log";
	}

	/**
	 * Gets a dojo based ajax guide for configuration of the plugin.
	 *
	 * @param IEmbedmentOutputHandler OutputHandler 
	 * @return IEmbedmentOutputHandler
	 * @access public
	 */
	public function &Configure($Identifier = null, &$EmbedmentOutputHandler ){
		//Load templates from files
		$Head = file_get_contents($this->Owner->GetCMS3Path() . "data/" . $this->GetPluginID() . "/ConfigHead.htm");
		$Body = file_get_contents($this->Owner->GetCMS3Path() . "data/" . $this->GetPluginID() . "/ConfigBody.htm");

		$LogFile = file_get_contents($this->Owner->GetCMS3Path() . "data/System/System.log");

		$Body = str_replace("LOGFILE",$LogFile ,$Body);

		//Parse the output
		$EmbedmentOutputHandler->ExtentHeader($Head);
		$EmbedmentOutputHandler->SetBody($Body);
		return $EmbedmentOutputHandler;
	}


		//Implementation of IPlugin

	/**
	 * Gets the pluginID of the plugin.
	 *
	 * @return string
	 * @access public
	 */
	public function GetPluginID( )
	{
		return "LogViewer";
	}


}


?>
