<?php
//              (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines CMS3_Wiki
*
* @package	Wiki
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
* Very simple plugin that allows creation of an image gallery
*/
class CMS3_Wiki extends CMS3_System_Plugin implements IProvidesContent, ILinkable, IConfigure, ISystemCallback, IRemove, IInstall
{

		//Implementation of IProvidesContent
	/**
	 * Print the page of a given identifier.
	 *
	 * @param string identifier Identifier of the requested page.

	 * @param IOutputHandler OutputHandler OutputHandler used the parse the output. You may disable this OutputHandler with
	* OutputHandler->Disable() and print the content manually.

	 * @return 
	 * @access public
	 */
	public function &GetPage( $identifier,  &$OutputHandler ){
		//Initialize body variable
		$body = "";

		//Get a url
		$Url = $this->Owner->GetCMS3URL() . $this->Owner->GetNamespace($this->GetPluginID()) . "/";

		//Use the first string before the first slash
		$cmd = explode("/",$identifier,2);
		switch($cmd[0])
		{
			case "Edit":
				$identifier = substr($identifier,5); //Cut of the Edit/
				//Include TinyMCE editor
				$head ="<script language='javascript' type='text/javascript' src='" . $this->Owner->GetCMS3URL() . "bin/Wiki/tiny_mce/tiny_mce.js'></script>";
				$head .= "<script language='javascript' type='text/javascript'>tinyMCE.init({mode : 'textareas', theme : 'simple' });</script>";
				$OutputHandler->ExtentHeader($head);
			
				//Select the latest revision of the page requested
				$Query = "SELECT Content From CMS3_Wiki WHERE Identifier = '" . $identifier . "' ORDER BY Revision DESC LIMIT 1";
				//Get database handle
				$dbh = $this->Owner->GetDatabaseHandle();
				//Execute query
				if(!$Result = mysql_query($Query, $dbh)){
					$this->Owner->LogMySQL($this->GetPluginID(), "Error while trying to get wikipage: $identifier for editing",  $dbh);
					//Redirect to root
					header("Location: " . $Url);
				}else{
					$body .= "<form action='" . $Url . "Save/" . $identifier . "' method='post'>";
					if(mysql_num_rows($Result) != 0){
						$body .= "<h1>Edit: " . ($identifier == "" ? "Wiki" : $identifier) ."</h1>";
						//Parse the content to body variable
						$Row = mysql_fetch_row($Result);
						$body .= "<textarea style='width: 98%; min-height: 300px;' name='Content'>" . $Row[0] . "</textarea>";
					}else{
						//Create new page
						$body .= "<h1>Create: " . $identifier ."</h1>";
						$body .= "<textarea style='width: 98%; min-height: 300px;' name='Content'>Create a new page...<br /></textarea>";
					}
					$body .= "<br/ ><input type='submit' value='Save' /></form>";
				}
			break;

			case "History":
				$identifier = substr($identifier,8); //Cut of the History/
				//List old revision of this identifier

				//Select a list of revisions of the page requested
				$Query = "SELECT Revision, Created From CMS3_Wiki WHERE Identifier = '" . $identifier . "' ORDER BY Revision DESC";
				//Get database handle
				$dbh = $this->Owner->GetDatabaseHandle();
				//Execute query
				if(!$Result = mysql_query($Query, $dbh)){
					$this->Owner->LogMySQL($this->GetPluginID(), "Error while trying to get revision: $identifier",  $dbh);
					//Redirect to root
					header("Location: " . $Url);
				}else{
					if(mysql_num_rows($Result) != 0){
						$body .= "<h1>History of " . ($identifier == "" ? "Wiki" : $identifier) . "</h1>";
						//Parse the content to body variable
						while($Row = mysql_fetch_array($Result, MYSQL_ASSOC)){
							$body .= "<a href='" . $Url .  "Revision/" . $Row["Revision"] . "'>Revision: " . $Row["Revision"] . " - " . date(DATE_RFC822, $Row["Created"]) . "</a><br>";
						}
					}else{
						//Redirect to editor
						header("Location: " . $Url . "Edit/" . $identifier);
					}
				}

			break;

			case "Revision":
				$identifier = substr($identifier,9); //Cut of the Revision/
				//Select the revision requested
				$Query = "SELECT Content, Created, Identifier From CMS3_Wiki WHERE Revision = '" . $identifier . "' LIMIT 1";
				//Get database handle
				$dbh = $this->Owner->GetDatabaseHandle();
				//Execute query
				if(!$Result = mysql_query($Query, $dbh)){
					$this->Owner->LogMySQL($this->GetPluginID(), "Error while trying to get revision: $identifier",  $dbh);
					//Redirect to root
					header("Location: " . $Url);
				}else{
					if(mysql_num_rows($Result) != 0){
						//Parse the content to body variable
						$Row = mysql_fetch_row($Result);
						$body .= "<h1>" . ($Row[2] == "" ? "Wiki" : $Row[2]) ."</h1><i>Revision: " . $identifier . ", created " . $Row[1] . "</i><p>" . $Row[0] . "</p>";
						$identifier = $Row[2];
					}else{
						//Redirect to root
						header("Location: " . $Url);
					}
				}
			break;

			case "Save":
				//Make the cut of the Save/ part, make it parseable for default
				$identifier = substr($identifier,5);
				//Always insert into
				$Query = "INSERT INTO CMS3_Wiki (Identifier, Content) VALUES ('" . $identifier . "', '" . $_POST["Content"] . "')";
				$dbh = $this->Owner->GetDatabaseHandle();
				//Execute query
				if(!$Result = mysql_query($Query, $dbh)){
					$this->Owner->LogMySQL($this->GetPluginID(), "Error while trying to get wikipage: $identifier",  $dbh);
				}
			default: //just display the page the identifier is identifing :)
				//Select the latest revision of the page requested
				$Query = "SELECT Content, Created, Revision From CMS3_Wiki WHERE Identifier = '" . $identifier . "' ORDER BY Revision DESC LIMIT 1";
				//Get database handle
				$dbh = $this->Owner->GetDatabaseHandle();
				//Execute query
				if(!$Result = mysql_query($Query, $dbh)){
					$this->Owner->LogMySQL($this->GetPluginID(), "Error while trying to get wikipage: $identifier",  $dbh);
					//Redirect to root
					header("Location: " . $Url);
				}else{
					if(mysql_num_rows($Result) != 0){
						//Parse the content to body variable
						$Row = mysql_fetch_row($Result);
						$body .= "<h1>" . ($identifier == "" ? "Wiki" : $identifier) ."</h1><i>Revision: " . $Row[2] . ", created " . $Row[1] . "</i><p>" . $Row[0] . "</p>";
					}else{
						//Redirect to editor
						header("Location: " . $Url . "Edit/" . $identifier);
					}
				}
			break;
		}

		//Add a little toolbar at the top of the wiki page
		$body = "<div style=\"float: right;\"><a href=\"" . $Url . $identifier . "\">Article</a> | <a href=\"" . $Url . "Edit/" . $identifier . "\">Edit</a> | <a href=\"" . $Url . "History/" . $identifier . "\">History</a></div><br />" . $body;

		$OutputHandler->SetTitle($identifier);
		$OutputHandler->SetBody($body);

		$OutputHandler->Parse();
		return $OutputHandler;
	}

		//Implementation of IPlugin

	/**
	 * Gets the pluginID of the plugin.
	 *
	 * @return string
	 * @access public
	 */
	public function GetPluginID( ){
		return "Wiki";
	}


	//Implementation of ILinkable

	/**
	 * Gets a list of links that the plugins exposes
	 * 
	 * Each entry in the array is an array with 3 fields, one for the display name, one for the URL of the page, and one for an array of sub entries. Each sub entry consits of 3 fields, just like the toplevel entries.
	 * 
	 * @access public
	 * @return array
	 */
	public function GetLinks( ){
		//Get out namespace
		if($Namespace = $this->Owner->GetNamespace($this->GetPluginID())){
			//Get a URL
			$URL = $this->Owner->GetCMS3URL() . $Namespace . "/";

			//Create an plugin entry
			$Links = array($Namespace,$URL, array());

			//Generate content
			$Query = "SELECT DISTINCT Identifier FROM CMS3_Wiki ORDER by Identifier";
			$Result = mysql_query($Query, $this->Owner->GetDatabaseHandle());

			if(mysql_num_rows($Result) != 0){
				while($Row = mysql_fetch_array($Result, MYSQL_ASSOC))
				{
					//Default page is representated as plugin entry
					if($Row["Identifier"] != "")
						$Links[2][] =array($Row["Identifier"], $URL . $Row["Identifier"] , null); 
				}
			}

			//Add toplevel array and return it
			return array($Links);
		}else{
			return array(array($this->GetPluginID(), null, null));
		}
	}

		//IConfigure implementation

	/**
	* Gets an absolute address of an icon for this plugin
	*/
	public function GetControlCenterIcon(){
		return $this->Owner->GetCMS3URL() . "bin/" . $this->GetPluginID() . "/icon.png";
	}

	/**
	* Gets menu entry string
	*/
	public function GetControlCenterMenuEntry(){
		//TODO: i18n
		return "Configure " . $this->GetPluginID();
	}

	/**
	 * Gets a dojo based ajax guide for configuration of the plugin.
	 *
	 * @param IEmbedmentOutputHandler OutputHandler 
	 * @return IEmbedmentOutputHandler
	 * @access public
	 */
	public function &Configure($Identifier = null, &$EmbedmentOutputHandler ){
		//Load templates from files
		$Head = file_get_contents($this->Owner->GetCMS3Path() . "data/" . $this->GetPluginID() . "/ConfigHead.htm");
		$Body = file_get_contents($this->Owner->GetCMS3Path() . "data/" . $this->GetPluginID() . "/ConfigBody.htm");

		$Body = str_replace("CMS3URL",$this->Owner->GetCMS3URL() ,$Body);
		$Body = str_replace("NAMESPACE",$this->Owner->GetNamespace($this->GetPluginID()) ,$Body);

		//Parse the output
		$EmbedmentOutputHandler->ExtentHeader($Head);
		$EmbedmentOutputHandler->SetBody($Body);
		return $EmbedmentOutputHandler;
	}

		//ISystemCallback implementation

	/**
	 * Handles a callback from ajax application.
	 *
	 * @param string data Data attached to this callback
	 * @return 
	 * @access public
	 */
	public function SystemCallback( $data ){
		if($data == "SaveNamespace"){
			//Find old namespace
			$OldNS = $this->Owner->GetNamespace($this->GetPluginID());

			//Does old namespace exist?
			if(!$OldNS){
				//If does not exist

				//TODO: remove illegal chars...
				//Try to register new namespace
				if($this->Owner->RegisterNamespace($_POST["Namespace"], $this->GetPluginID())){
					print "TRUE";
				}else{
						//TODO i18n
					print "Registration failed, make sure you have chosen a unique namespace.";
				}
			}else{
				//If does exist
				
				//Unregister current namespace (should not be able to fail)
				if($this->Owner->UnregisterNamespace($OldNS)) //NOTE: a plugin can't have two namespaces due to database layout.
				{
					//TODO: remove illegal chars...
					//Try to register new namespace
					if($this->Owner->RegisterNamespace($_POST["Namespace"], $this->GetPluginID())){
						print "TRUE";
					}else{
						//Try to reregister old namespace
						if($this->Owner->RegisterNamespace($OldNS, $this->GetPluginID())){
								//TODO i18n
							print "Registration failed, make sure you have chosen a unique namespace. You still have the old namespace.";
						}else{
								//TODO i18n
							print "Registration failed, make sure you have chosen a unique namespace. You don't have any namespace now.";
							//Not owning any namespace
						}
					}
				}else{
					//Could not unregister current namespace
						//TODO: i18n
					$msg = "Unregistration of current namespace failed."; 
					print $msg;
					$this->Owner->Log($this->GetPluginID(), $msg);
				}
			}
		}else{
			//If identifier doesn't identify the request just give a soft 404..
			print "Error: 404, data not found.";
		}
	}

		//Implementation of IInstall

	/**
	 * Runs a script to complet installation
	 *
	 * This creates database tables, and default data.
	 *
	 * @return bool True if installations script went okay, otherwise return false.
	 * @access public
	 */
	public function Install()
	{
		//Get database handle
		$dbh = $this->Owner->GetDatabaseHandle();

		//Create a table
		if(!mysql_query("CREATE TABLE IF NOT EXISTS `CMS3_Wiki` (   `Revision` int(11) NOT NULL auto_increment,   `Identifier` varchar(255) NOT NULL,   `Content` text NOT NULL,   `Created` timestamp NOT NULL default CURRENT_TIMESTAMP,   PRIMARY KEY  (`Revision`),   KEY `Identifier` (`Identifier`) ) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 AUTO_INCREMENT=5", $dbh )) 
		{
			//Log potentiol errors
			$this->Owner->LogMySQL($this->GetPluginID(), "Error during creating of tables ", $dbh);
			return false;
		}else{
			return true;
		}
	}

		//Implementation of IRemove
	/**
	 * Removes files and databases created after fysical installation
	 *
	 * @return bool true/false depending on success
	 * @access public
	 */
	public function Remove( )
	{
		//Unregister namespace
		$this->Owner->UnregisterNamespace($this->Owner->GetNamespace($this->GetPluginID()));

		//Drop tables
		$sql = 'DROP TABLE CMS3_Wiki';
		$dbh = $this->Owner->GetDatabaseHandle();
		if(mysql_query($sql,  $dbh)) 
		{
			return true;
		}else{	
			$this->Owner->LogMySQL($this->GetPluginID(), "Error during deletion of database table " ,$dbh);
			return false;
		}
	}

}


?>
