<?php
//              (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines CMS3_Help_IProvidesHelp
*
* @package	Help
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IPlugin
*/
require_once("share/System/IPlugin.php");

/**
*A plugin that implements this interfaces exposes data that will be available for the Help plugin.
*/
interface CMS3_Help_IProvidesHelp extends IPlugin
{
	/**
	*Gets a list of the help available for this plugin
	*
	*This method returns a list of toplevel subjects, only one or two toplevel subjects, each toplevel subject is an array with 3 fields number zero a title, number one the body text of the help page (in HTML) and number 2 is an array of subsubjects. Each subsubject consists of the same as the toplevel subjects.
	*
	*Return array List of help subjects and subsubjects
	*/
	public function GetHelp();
}



?>
