<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines an abstract implementation of IPlugin
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IPlugin
*/
require_once("share/System/IPlugin.php");


/**
 * An abstract implementation of the Register method from IPlugin
 */
abstract class CMS3_System_Plugin implements IPlugin
{

	/**
	* Referance to the MainClass owning this instance
	*/
	protected $Owner = null;


	/**
	 * Register the owner of this plugin. 
	 *
	 * @param CMS3_MainClass Owner The CMS3_MainClass that owns this plugin, gives the plugin ability to get data from CMS3_MainClass
	 * @access public
	 */
	public function Register( &$Owner )
	{
		$this->Owner =& $Owner;
	}


} // end of IPlugin
?>
