<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines IEmbedmentOutputHandler
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IPlugin
*/
require_once("share/System/IPlugin.php");

/**
 * Interface IEmbedmentOutputHandler, used for processing embedments
 */
interface IEmbedmentOutputHandler extends IPlugin
{

	/** Aggregations: */

	/** Compositions: */

	/**
	 * Data provided by use of this method may be left out if the OutputHandler wishes
	 * to print something else the HTML, therefor don't add important information
	 * here.
	 *
	 * @param string line A line you wish to add to the header.

	 * @return 
	 * @access public
	 */
	public function ExtentHeader( $line );

	/**
	 * Set the body if the page, read parameter documentation.
	 *
	 * @param string body Body of the page, or description of a channel.

	 * @param array List Parse a list, use this feature if you wish to parse a list. This will also
	 * enable to OutputHandler to print a feed. This parameter is optional, if set the
	 * first parameter will define the description of the channel, and every body and
	 * title in this array will define an entry.
	 * Array layout:
	 * [body,body,...]
	 * or
	 * [[title,body],[title,body],...]

	 * @return 
	 * @access public
	 */
	public function SetBody( $body,  $List = null );
	 // end of member function SetBody


	/**
	*Gets content ready to be printed
	*
	*This does not include header, only the body content.
	*
	*@return string Content ready for print
	*/
	public function GetContent();

	/**
	*Gets the header extension
	*
	*@return string Lines to be added to the header
	*/
	public function GetHeader();

			//Decleared in parents
	/*  *
	 *
	 * @param CMS3_System Owner The CMS3_System that owns this plugin, gives the plugin ability to get data from
CMS3_System

	 * @return 
	 * @access public
	 */
	//public function Register( $Owner );

	/*  *
	 * Gets the pluginID of the plugin.
	 *
	 * @return string
	 * @access public
	 */
	//public function GetPluginID( );

} // end of IEmbedmentOutputHandler
?>
