<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines ILinkable
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IProvidesContent
*/
require_once("share/System/IProvidesContent.php");

/**
 * class ILinkable, implement this if your plugin exposes links
 */
interface ILinkable extends IProvidesContent
{

	/** Aggregations: */

	/** Compositions: */

	/**
	 * Gets a of links that the plugins exposes
	 * 
	 * Each entry in the array is an array with 3 fields, one for the display name, one for the URL of the page, and one for an array of sub entries. Each sub entry consits of 3 fields, just like the toplevel entries.
	 * Please do only have on or two toplevel entries, then make the rest sub entries or subsubentriues or subsubsubsub... 
	 * 
	 * @return array
	 * @access public
	 */
	public function GetLinks( );


} // end of ILinkable
?>
