<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines IOutputHandler
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IEmbedmentOutputHandler
*/
require_once("share/System/IEmbedmentOutputHandler.php");

/**
 * class IOutputHandler, implement this if your plugin is and OutputHandler
 */
interface IOutputHandler extends IEmbedmentOutputHandler
{

	/**
	*Sets the complete unique identifier.
	*
	*@param string Idenfitifer Complete unique identifier.
	*@access public
	*/
	public function SetIdentifier($Identifier = "");

	/** Aggregations: */

	/** Compositions: */

	/**
	 * Print an error code, if you use this method no other methods will be available.
	 *
	 * @param string msg The message you wish to print

	 * @param int code The error code you wish to print eg. 404.

	 * @return 
	 * @access public
	 */
	public function PrintError( $msg,  $code );
	// end of member function PrintError

	/**
	 * Set the title of the page
	 *
	 * @param string title Title of the page, channel etc.

	 * @return 
	 * @access public
	 */
	public function SetTitle( $title );
	 // end of member function SetTitle

	/**
	 * Diable the OutputHandler, do this if you wish to print binary data.
	 *
	 * @return 
	 * @access public
	 */
	public function Disable( );
	// end of member function Disable

	/**
	 * Gets to original identifier specified as <Namespace>/<PluginID>.<ext>
	 * Do this if you wish to extraxt the extention and parse manually.
	 *
	 * @return string
	 * @access public
	 */
	public function GetIdentifier( );
	 // end of member function GetIdentifier

	/**
	 * Print the content, should also be called from GetPage().
	 *
	 * @return 
	 * @access public
	 */
	public function Parse( );
	 // end of member function Parse


} // end of IOutputHandler
?>
