<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines IProvidesContent
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IPlugin
*/
require_once("share/System/IPlugin.php");

/**
 * class IProvidesContent, Implement this if you plugin exposes viewable content
 * 
 * If you implement this interface you should make sure to register a namespace
 */
interface IProvidesContent extends IPlugin
{

	/** Aggregations: */

	/** Compositions: */


	/**
	 * Print the page of a given identifier.
	 *
	 * @param string identifier Identifier of the requested page.

	 * @param IOutputHandler OutputHandler OutputHandler used the parse the output. You may disable this OutputHandler with
	* OutputHandler->Disable() and print the content manually.

	 * @return 
	 * @access public
	 */
	public function &GetPage( $identifier,  &$OutputHandler );

} // end of IProvidesContent
?>
