<?php     
//          (F)
// CMS3 - A Three Content Management System.
// Copyright (C) 2007  Jop... (Jonas F. Jensen).
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

/**
*This file defines IProvidesEditor
*
* @package	System
* @author	Jonas F. Jensen <jopsen@gmail.com>
* @copyright	2007 Jonas F. Jensen.
* @license	http://www.gnu.org/licenses/gpl.txt
*/

/**
*The interface defined in this file depends on IPlugin
*/
require_once("share/System/IPlugin.php");

/**
 * class IProvidesEditor, implement this if your plugin should expose an editor in the backend.
 */
interface IProvidesEditor extends IPlugin
{

	/**
	 * Gets an Ajax guide for modification of the content.
	 *
	 * @param IEmbedmentOutputHandler EmbedmentOutputHandler Outputhandler the content MUST be parse to.
	* @param string Identifier String at the end of the URL
	 * @return IEmbedmentOutputHandler
	 * @access public
	 */
	public function &ModifyContent($Identifier = null, &$EmbedmentOutputHandler);

	/**
	* Gets an absolute address of an icon for this plugin
	*/
	public function GetSystemIcon();

	/**
	* Gets menu entry string
	*/
	public function GetSystemMenuEntry();
}
?>
